var g_objAPI = null;
var g_bIs2004 = false;

/*
usage:
<BODY onLoad="ScormInitialize()" onUnload="ScormTerminate()">
*/

function ScormInitialize()
{
    if (!FindAPI()) {
        alert("The LMS's API is not found.")
        return false;
    }
    if (!VerifyLMS()) return false;
    var result = "";

    if (g_bIs2004) {
        result = g_objAPI.Initialize("");
    } else {
        result = g_objAPI.LMSInitialize("");
    }
    if (result.toString() != "true") {
        var err = ErrorHandler();
    }
    return result.toString();
}

function ScormTerminate()
{
    if (!VerifyLMS()) return false;
    var result = "";
    if (g_bIs2004) {
        result = g_objAPI.Terminate("");
    } else {
        result = g_objAPI.LMSFinish("");
    }
    if (result.toString() != "true") {
        var err = ErrorHandler();
    }
    return result.toString();
}

function ScormGetValue(name)
{
    if (!VerifyLMS()) return false;
    var value = "";
    if (g_bIs2004) {
        value = g_objAPI.GetValue(name);
    } else {
        value = g_objAPI.LMSGetValue(name);
    }
    var errCode = ScormGetLastError();
    if (errCode != 0) {
        var errDescription = ScormGetErrorString(errCode);
        alert("ScormGetValue(" + name + ") failed. \n" + errDescription);
        return "";
    }
    return value.toString();
}

function ScormSetValue(name, value)
{
    if (!VerifyLMS()) return false;

    var result = "";
    if (g_bIs2004) {
        result = g_objAPI.SetValue(name, value);
    } else {
        result = g_objAPI.LMSSetValue(name, value);
    }
    if (result.toString() != "true") {
        ErrorHandler();
    }
}

function ScormCommit()
{
    if (!VerifyLMS()) return false;
    var result = "";
    if (g_bIs2004) {
        result = g_objAPI.Commit("");
    } else {
        result = g_objAPI.LMSCommit("");
    }
    if (result.toString() != "true") {
        ErrorHandler();
    }
}

function ScormGetLastError()
{
    if (!VerifyLMS()) return false;
    if (g_bIs2004) {
        return g_objAPI.GetLastError();
    }
    return g_objAPI.LMSGetLastError()
}

function ScormGetErrorString(errorCode)
{
    if (!VerifyLMS()) return false;
    if (g_bIs2004) {
        return g_objAPI.GetErrorString(errorCode);
    }
    return g_objAPI.LMSGetErrorString(errorCode);
}

function ScormGetDiagnostic(errorCode)
{
    if (!VerifyLMS()) return false;
    if (g_bIs2004) {
        return g_objAPI.GetDiagnostic(errorCode);
    }
    return g_objAPI.LMSGetDiagnostic(errorCode);
}

function ErrorHandler()
{
    if (!VerifyLMS()) return false;
    var errCode = ScormGetLastError().toString();
    if (errCode != "0") {
        var errDescription = ScormGetErrorString(errCode);
        alert("Error: "+errDescription);
    }
    return errCode;
}

function FindAPI() {

    if (g_objAPI != null)
        return true;
    var win = window;

    while (win != null && (win != win.parent || win.opener!=null) && win.API == null && win.API_1484_11 == null) {
        win = (win.opener == null) ? win.parent : win.opener;
    }
    if (win.API_1484_11 != null) {
        g_objAPI = win.API_1484_11;
        g_bIs2004 = true;
        return true;
    } else if (win.API != null) {
        g_objAPI = win.API;
        g_bIs2004 = false;
        return true;
    } 
    g_objAPI = null;
    return false;
}

function VerifyLMS()
{
    if (g_objAPI == null) {
        alert("The LMS's API is not found.")
        return false;
    }
    return true;
}
